**************************************************************************
*                 Bn is a function of the RIBO code                      *
**************************************************************************
*            CUSTOMIZE THIS FUNCTION TO FIT YOUR CONDITIONS              *
**************************************************************************
*                                BBBB                                    *
*                                B   B                                   *
*                                BBBB                                    *
*                                B   B                                   *
*                                BBBB                                    *
**************************************************************************
*                                                                        *
*          DEPENDENCIES:                                                 *
*                                                                        *
*           Bn ----| (O)                                                 *
*                  |---> B ---| (S)                                      *
*                             |---> explicitEM---| (S)                   *
*                                                |---> main.f (S)        *
*                                                                        *
*------------------------------------------------------------------------*
*          MEANING:                                                      *
*                                                                        *
*          *)  Bn is the nth component of the magnetic field             *
*              Thus, B={B1,B2,B3}                                        *
*              [Bn] = T                                                  *
*------------------------------------------------------------------------*
*          VARIABLES:                                                    *
*                                                                        *
*          *)  X0(4) {space,time} four-vector                            *
*              [X0]={m,m,m,s]                                            *
*                                                                        *
**************************************************************************

       FUNCTION Bn(X0,n)
         real*8 X0(4),Bn
         integer*4 n
         Bn=0.0
         IF (n.eq.1) THEN
           Bn=0.0
         ELSE IF (n.eq.2) THEN
           Bn=0.0         
         ELSE IF (n.eq.3) THEN
           Bn=0.0
*           Bn=1.0+X0(3)/10  
         END IF
       END       
       

       
       
