*******************************************************************************
****     EEEEE  M   M  II  TTTTT  TTTTT   AAA   N   N   CCCC  EEEEE      *****
****     E      MM MM  II    T      T    A   A  NN  N  C      E          **** 
****     EEEE   M M M  II    T      T    AAAAA  N N N  C      EEEE       ***
****     E      M   M  II    T      T    A   A  N  NN  C      E          ****
****     EEEEE  M   M  II    T      T    A   A  N   N   CCCC  EEEEE      *****
********************************************************************************
*        The RIBO project, MARIO SANTANA LEITNER 2000-2006 
*------------------------------------------------------------------------
       SUBROUTINE emittance(epsilon,X3,U3)
        real*8 X3(3),U3(3)                                               ! i
        real*8 epsilon(2)                                                ! o     
        real*8 R(2),Pi                                                   ! a
**************************************************************************
*               CUSTOMIZE THIS FUNCTION TO FIT YOUR PROBLEM              *
*   USAGE:  print emittance maps in a given cross section f              *
*                                                                        *
*   VARIABLES:                                                           *
*             INPUT                                                      *
*     X3(3)  -------  Absolute position (x,y,z)[cm]                      *
*     U3(3)  -------  Velocity {ux,uy,uz} of the ion [m/s]               *
*           AUXILIARY                                                    *
*     R(2)   -------                                                     *
*     Pi     -------  3.141592...                                        *
*            OUTPUT                                                      *
*     epsilon(2) ---  Emittance in perpendicular directions              * 
*     R(2)   -------  Transverse position of the beam axis [cm]          *
*                                                                        *
**************************************************************************
*
        Pi=3.14159257
*    Modify this according to the exit axis and position
        R(1)=X3(1)-0.0
        R(2)=U3(3)-1.0
*    Safeguard condition
        IF (U3(3).eq.0.0) THEN
          write(6,*)'Warning:extraction axis perpendicular to velocity'
          U3(3)=1E-12
        END IF
        write(4,'(1X,F8.4,F9.5,F8.4,F9.5)')R(1),U3(1)/U3(3),R(2)
     $       ,U3(2)/U3(3)
        epsilon(1)=epsilon(1)+10*R(1)*1000*atan(U3(1)/U3(3))/Pi
        epsilon(2)=epsilon(2)+10*R(2)*1000*atan(U3(2)/U3(3))/Pi
       END
