      SUBROUTINE powderdesorption(COLPOW,celln,tdep,ts)
       integer*4 celln                                                   ! i 
       real*8 COLPOW,ts                                                  ! i
       real*8 tdep                                                       ! i/o
       external rand
**************************************************************************
*                                                                        *
*     WRITTEN BY:                                                        *
*                        MARIO SANTANA LEITNER, 2006                     *
*                                                                        * 
*----------------------------------------------------------------------- *
*                                                                        *
*               CUSTOMIZE THIS FUNCTION TO FIT YOUR PROBLEM              *
*   USE:  add customized desorption time within a powder cell            *
*   NOTE: normally at the end of the history, the amount ts * (COLP)     *
*           is added if tdep is zero                                     *
*         don't try to sample from distributions (i.e. Frenkel) because  *
*           here we check after a bunch of collisions (actually when the *
*           particle exits the powder cell), and NOT after each          *
*           collision. This will not imply any big error (central limit  *
*           theorem)                                                     *
*   HIGHLIGHTS:                                                          *
*           - simulation of COLD spots                                   *
*                                                                        *
*   THIS ROUTINE IS ALWAYS READ THROUGH                                  *
*                                                                        *
*   VARIABLES:                                                           *
*             INPUT                                                      *
*     celln   ------  Cell (region)  (from input file)                   *
*     COLLPOW  -----  Number of collisions in the powder cell in the     *
*                         last passage through                           *
*     ts     -------  average sticking time per collision                *
*                         (given at runtime)                             *
*             I/OUT                                                      * 
*     tdep   -------  Particle elapsed desorption time spent in powder   *
*                        domains [s]                                     *
*            EXTERNAL                                                    *
*     rand   -------  Seed for random generation                         *
*                                                                        *
**************************************************************************
*
*
*------------------------------------------------------------------------*
*  EXAMPLE 1, cells 1, 3, 5 contain powder, the first one is warmer than *
*    the second and that one is warmer than the third                    *
*------------------------------------------------------------------------* 
*       IF (celln.eq.1) THEN
*         tdep = tdep + 1.0*ts
*       ELSE IF (celln.eq.3) THEN
*         tdep = tdep + 2.0*ts
*       ELSE IF (celln.eq.5) THEN
*         tdep = tdep + 3.0*ts
*       END IF
      END      
