      SUBROUTINE userprint(ofile,td,tp,ts,tPo,tde,tdep,COL,COLP,COL6,U3,
     $     X3,X03,ocell,celln,ion,ads,survec,endvec) 
       character*20 ofile                                                ! i
       integer*4 ocell,celln,ion,ads,survec(11),endvec(11)               ! i 
       real*8 X03(3),X3(3),U3(3)                                         ! i   
       real*8 COL,COLP,COL6(6),td,ts,tde,tdep,tPo,teff,tp,tT             ! i
       real*8 V3scaV3,norm,eve                                           ! a
       logical fileNOTyetOPEN(5)                                         ! a
       external rand                                                     ! e
**************************************************************************
*                                                                        *
*     WRITTEN BY:                                                        *
*                        MARIO SANTANA LEITNER, 2006                     *
*                                                                        * 
*----------------------------------------------------------------------- *
*               CUSTOMIZE THIS FUNCTION TO FIT YOUR PROBLEM              *
*   USAGE:  print values after each history, eg. x,y,z,teff              *
*                                                                        *
*   VARIABLES:                                                           *
*               INPUT                                                    *
*     ofile  -------  Output file                                        *
*     ocell  -------  Cell where particle was born                       *
*     celln  -------  Cell where particle trajectory ends                *
*     ion    -------  Ionic state: 0 = neutral, 1 = ionized              *
*     ads    -------  Adsorption:  0 = none, 1 = particle was adsorbed   *
*     endvec(11) ---  Tells which of the paths (you can put up to 11)    *
*                          has been first completed. In normal cases     *
*                          (a single end surface) this is not relevant   *        
*     survec(11) ---  Tells which is the end surface                     *
*     X03(3) -------  Absolute position at starting point (x0,y0,z0)[cm] *                        
*     X3(3)  -------  Absolute position at end point (xf,yf,zf)[cm]      *
*     U3(3)  -------  End velocity {ux,uy,uz} of the atom [m/s]          *
*     COL    -------  Total number of collisions outside powder/particle *
*     COLP   -------  Total number of collisions inside powder/particle  *
*     COLP6(6) -----  Collisions of type i per particle                  *
*     td     -------  Diffusion release time [s]                         *
*     ts     -------  Sticking time per collision [s/coll]               *
*     tde    -------  Particle elapsed desorption time spent in surfaces *
*                        other than those of the powder [s]              *
*     tdep   -------  Particle elapsed desorption time spent in powder   *
*                        cells [s]                                       *
*     tPo    -------  Flight time in the powder [s]                      *
*     teff   -------  Flight time outside the powder [s]                 *
*     tp     -------  Total effusion time:                               *
*                        tp = teff + tPo + ts * (COL+COLP)               *
*     tT     -------  Total release time per particle:                   *
*     fileNOTyetOPEN -- Logical array that serves to create the output   *
*                        files 21 to 25 just the first time              *
*                        tT = tp + td                                    *
*           AUXILIARY                                                    *
*     eve    -------  Event index:                                       *
*                        eve = ion + 2 * ads                             *
*     ...                                                                *
*            EXTERNAL                                                    *
*     rand   -------  Seed for random generation                         *
*                                                                        *
*   OUTPUT UNITS                                                         *
*     - UNITS 21-25 are available for the user                           *
*                                                                        *
**************************************************************************
*
*
*------------------------------------------------------------------------*
**   EXAMPLE 1: write to unit 21 the final and initial radius in a       *
**      cylinder oriented with axis z                                    *
*------------------------------------------------------------------------*
*        DATA fileNOTyetOPEN(1) / .TRUE. /
*        IF ( fileNOTyetOPEN(1)) THEN
*        fileNOTyetOPEN(1) = .FALSE.
*        OPEN(UNIT=21,FILE='21.out')
*        write(6,*)'Creating file unit 21'
*        END IF
**        
*        write(21,FMT='(1X,2F9.6)')sqrt(X3(1)**2+X3(2)**2),
*     $      sqrt(X03(1)**2+X03(2)**2)
*
*------------------------------------------------------------------------*
**   EXAMPLE 2: write to unit 22 the number of collisions of each type   *
*------------------------------------------------------------------------*
*        DATA fileNOTyetOPEN(2) / .TRUE. /
*        IF ( fileNOTyetOPEN(2)) THEN
*        fileNOTyetOPEN(2) = .FALSE.
*        OPEN(UNIT=22,FILE='22.out')
*        write(6,*)'Creating file unit 22'
*        END IF       
*        write(22,FMT='(1X,8F9.2)')COL,COLP,COL6
*     $      sqrt(X03(1)**2+X03(2)**2)
      END
