#!/bin/bash
# $1=input_file, either *.t or *.pov $2=resolution, 1,2,3
echo type './3D-view.sh inputfile_without_path resolution'
if [ $# -ge 2 ]
then
cd ..
 ext=`echo $1 | cut -d. -f2`
dest=`echo $1 | cut -d. -f1`
echo $ext $dest
if [ $ext != pov ] 
then
./RIBO<<file
$1
test$
-1
file
sed 's/QN /QN/' file.pov > $dest.pov
rm file.pov batch
fi
if [ $2 -eq 2 ]
then
povray -I$dest.pov -O$dest.tga +H480 +W640
elif [ $2 -eq 3 ]
then
povray -I$dest.pov -O$dest.tga +H960 +W1280
else
povray -I$dest.pov -O$dest.tga +H240 +W320
fi
mv $dest.tga ./figs
display ./figs/$dest.tga
cd -
else
echo "please, specify the input file and the resolution"
fi
