***************************************************************************
*IMPORTANT !!! Please read carefully the DISCLAIMER and the USER LICENSE prior to downloading and using the software.

*DISCLAIMER
*----------

*THIS SOFTWARE IS PROVIDED BY ISOLDE-TARGISOL, CERN, THE AUTHOR, AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL CERN-ISOLDE, CERN, THE AUTHOR, OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

*USER LICENSE
*------------

*By downloading the distribution files, you agree with the following conditions:

*Title to the downloaded materials and all copies thereof remain with the ISOLDE, the European Organization for Nuclear Research (CERN for brief) and the author, M. Santana Leitner.

*CERN-ISOLDE, and the author are the only official source of distribution of the code, bug fixes and documentation, as well as the unique recipients of the code intellectual property.

*The software can be downloaded after explicit acceptance of these conditions only from the dedicated CERN WEB server (http://msantana.web.cern.ch/msantana).

*The downloaded software cannot be redistributed as a whole, partly or in any modified way. Please, address interested users to the provided website.

*The downloaded software can be used free of charge by scientific and non profit organization. For commercial use ad hoc agreements have to be negotiated.

*The code or parts of it can be inserted into other codes only after an official permission is granted by CERN-ISOLDE, AND the author. The combined software, after the permission is obtained, can be used free of charge by scientific and non profit organizations. For commercial use ad hoc agreements have to be negotiated.

*The author welcomes user contribution to the code, that might be included in the code, acknowledging and properly referencing the originators. Possible contributions to the code must be sent separately and documented to the author, who will be the sole responsible for accepting them for inclusion in the distributed code.

*The use of the code must be acknowledged explicitly by quoting the following reference:

*- M. Santana Leitner, "A Monte Carlo code to optimize the production of radioactive ion beams by the ISOL Technique.", Ph.D. Thesis, UPC-ETSEIB (2005).

*Moreover users of the code are asked to provide feedback (through the website) about the activities to which it is used and the degree of success of the application of the code.
* For questions/clarifications/problems about the license please go to http://cern.ch/ribo'
* Use this website for any updates and documentation.
********************************************************************************
      
      PROGRAM init
        real*8 a,tm
        integer*4 m,k
      
        write(6,*)'Width?[cm]'
        a=20
*        read *,a
        write(6,*)'Number of space divisions?'
        m=6
        read *,m
        write(6,*)'Maximum time?[s]'
        tm=10
*        read *,tm	
        write(6,*)'Number of time intervals?'
        k=6
        read *,k
        CALL main(a,m,k,tm)
      END

      SUBROUTINE main(a,m,k,tm)
        real*8 N(m,2),D(m),Dc,NT,N0,NM,dN1,dN2,t,tm,dt,a,da
        integer*4 m,i,j,k
        da=a/m
        dt=tm/k
        write(6,*)'Diffusion Coefficient?'
        read *,Dc     
        t=0
        j=1
        write(6,*)'a,tm,da,dt',a,tm,da,dt
        CALL fillbins(N,D,Dc,m,a)
        DO WHILE (t.lt.tm)
          dt=dt*1.2
          dNMax=-1
          DO WHILE (dNMax.le.-0.5)
            dt=dt/1.2
            i=1
              dN1=min(D(i)*dt*(0-N(i,1))/(N(i,1)*0.5*da),0.0)
              dN2=min(D(i)*dt*(N(i+1,1)-N(i,1))/(N(i,1)*da),0.0)
              dNMax=min(dN1/N(i,1),dN2/N(i,1))
            i=2
            DO WHILE (i.le.m-1)
              dN1=min(D(i)*dt*(N(i-1,1)-N(i,1))/(N(i,1)*da),0.0)
              dN2=min(D(i)*dt*(N(i+1,1)-N(i,1))/(N(i,1)*da),0.0)
              dNMax=min(dN1/N(i,1),dN2/N(i,1),dNmax)
              i=i+1
            END DO
*           i=m
              dN1=min(D(i)*dt*(N(i-1,1)-N(i,1))/(N(i,1)*da),0.0)
              dN2=min(D(i)*dt*(0-N(i,1))/(N(i,1)*0.5*da),0.0)
              dNMax=min(dN1/N(i,1),dN2/N(i,1),dNmax)	    
          END DO
****************************************************
          i=1
            CALL sumNT(NT,j,N,m)
            dN1=min(D(i)*dt*(0-N(i,1))/(N(i,1)*0.5*da),0.0)
            dN2=min(D(i)*dt*(N(i+1,1)-N(i,1))/(N(i,1)*da),0.0)
            N0=N0-dN1
            N(i,2)=N(i,2)+dN1+dN2
            N(i+1,2)=N(i+1,2)-dN2
          i=2
          DO WHILE (i.le.m-1)
            dN1=min(D(i)*dt*(N(i-1,1)-N(i,1))/(N(i,1)*da),0.0)
            dN2=min(D(i)*dt*(N(i+1,1)-N(i,1))/(N(i,1)*da),0.0)
            N(i-1,2)=N(i-1,2)-dN1
            N(i,2)=N(i,2)+dN1+dN2
            N(i+1,2)=N(i+1,2)-dN2
            i=i+1
          END DO
*         i=m
            dN1=min(D(i)*dt*(N(i-1,1)-N(i,1))/(N(i,1)*da),0.0)
            dN2=min(D(i)*dt*(0-N(i,1))/(N(i,1)*0.5*da),0.0)
            N(i-1,2)=N(i-1,2)-dN1            
            N(i,2)=N(i,2)+dN1+dN2
            NM=NM-dN2
          t=t+dt
          j=j+1
*          write(6,*)'N',N
          write(6,*)'fraction',100*NT/(m*1000),t,k
*          write(6,'(1X,6F10.3)')N
          CALL updateNm(N,m)          
        END DO
*        write(6,*)'NT',NT 
      END

      SUBROUTINE fillbins(N,D,Dc,m,a)
        real*8 N(m,2),D(m),a,x,Dc
        integer*4 m,i
        i=1
        DO WHILE (i.le.m)
          x=(a/m)*(i-0.5)
          N(i,1)=functC(x,a)
          N(i,2)=N(i,1)
          D(i)=Dc*functD(x,a)
          i=i+1
        END DO
        i=1
        write(6,'(1X,6F10.3)')N
      END
      
      SUBROUTINE sumNT(NT,j,N,m)      
        real*8 N(m,2),NT
        integer*4 i,m,j
        i=1
        NT=0
        DO WHILE (i.le.m)
          NT=NT+N(i,1)
          i=i+1
        END DO  
      END
      
      SUBROUTINE updateNm(N,m)
        real*8 N(m,2)
        integer*4 i,m,j,k
        i=1
        DO WHILE (i.le.m)
          N(i,1)=N(i,2)
          i=i+1
        END DO
      END
      
      FUNCTION functC(x,a)
        real*8 x,a
*        functC=1000*sin(x*3.1415927/a)
        functC=1000
      END
      
      FUNCTION functD(x,a)
        real*8 x,a
        functD=1
      END
